#include "RAM.h"

//----------------------------------------------------------------------------------
// chargement du contenu de la RAM,  partir d'un fichier
//----------------------------------------------------------------------------------
int loadRAM(BOITE *boite, char *path)
{
	int i;
	char temp[9];
	char path_bin[74];
	unsigned char *buffer;
	FILE *fichier;
	fichier=fopen(path,"r");
	boite->status=0;
	if(fichier==NULL)
	{
		return 0;
	}
	else
	{
                //si l'extension du fichier est vnb on ne compile pas sinon oui !
		fclose(fichier);
		i=0;
		//on quitte la boucle si on trouve une extension ,si on arrvie a la fin de la chaine
		//ou si le nom de la chaine est trop long
		strcpy(path_bin,"./");
		while((path[i]!='.')&&(path[i]!='\0')&&(i<70))
		{
			path_bin[i+2]=path[i]; //+2 car il faut sautter le "./"
			i++;
		}
		path_bin[i+2]='\0';//+2 car il faut sautter le "./"
		if(strcmp(path+i,".vnb")!=0)
		{
			strcat(path_bin,".vnb");
			compil(path,path_bin);
		}
		else
			strcpy(path_bin,path);
		fichier = fopen(path_bin,"r");
		buffer = (unsigned char*)malloc(sizeof(unsigned char)*taille_RAM);
		free(boite->buffer);

		for(i=0;i<taille_RAM;i++)
		{
			strcpy(temp,"00000000");// on initialise temp a 0 au cas ou la lecture serait impossible
			if(!feof(fichier))
				fread(temp,1,8,fichier);
			buffer[i]=(unsigned char)strtol(temp,(char **)NULL,2);  // converti temp (chaine de binaire) en entier
		}
		fclose(fichier);
		boite->buffer = buffer;
		boite->status = 1;
		return 1;
	}
}


//----------------------------------------------------------------------------------
// indique la case de la RAM en cours de lecture
//----------------------------------------------------------------------------------
void surbrillance(BOITE *tab,int val)
{
	int x=27,y=0;
	y+=(int)(val/8)*10;
	x+=(val % 8)*15;
	XUnmapWindow(display,surbrille_.win); // on efface la boite permettant la surbrillance de la RAM et la RAM
	XUnmapWindow(display,RAM_.win);
	XDestroyWindow(display,surbrille_.win); // on detruit la boite de surbrillance afin de la reconstruire d'une autre couleur (initialisation)
	surbrille_.win = XCreateSimpleWindow(display, RAM_.win,x,y,14,10,1,rouge_1,rouge_2);
	surbrille_.val = RAM_.buffer[val];
	Dessiner(&surbrille_);
	Dessiner(&RAM_);
}


