#include "compil.h"

void compil(char *path,char *path_bin)
{
	char temp[7];
	char bin[9];
	int modif1,modif2,modif,j,arite;
	FILE *source=fopen(path, "r");
	FILE *binaire=fopen(path_bin, "w");
	//do
	while(!feof(source))
	{
		strcpy(temp,"");// on  remts a nul
		fscanf(source, "%s", temp);
		analyse(temp,&arite, &modif1, &modif2, binaire); // modifx=1 si l'argument x est une adr, -1 si reg, 10 si val, 4 si pph
		for(j=1;j<=arite;j++)
		{
			modif = ( (j==1) ? modif1 : modif2 );
			fscanf(source, "%s", temp);
			if(modif==1) // adr
				fprintf(binaire, "%s", adr2bin(temp,bin));
			if(modif==-1)  //reg
				fprintf(binaire, "%s", reg2bin(temp,bin));
			if(modif==10) //val
				fprintf(binaire, "%s", val2bin(temp,bin));
			if(modif==4) //pph
				fprintf(binaire, "%s", pph2bin(temp,bin));
		}
	}
	fclose(source);
	fclose(binaire);
}


//-----------------------------------------------------------------------------------------------------------------------------

int analyse(char *temp, int *arite, int *modif1, int *modif2, FILE *binaire)
{
	if(strcmp(temp, "NOP")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00000000");
		return 1;
	}

	if(strcmp(temp, "LOAD")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00000001");
		return 1;
	}

	if(strcmp(temp, "LDI")==0)
	{
		*modif1=10;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00000010");
		return 1;
	}

	if(strcmp(temp, "LDXR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00000011");
		return 1;
	}

	if(strcmp(temp, "LDX")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00000100");
		return 1;
	}

	if(strcmp(temp, "LI")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00000101");
		return 1;
	}

	if(strcmp(temp, "MOVE")==0)
	{
		*modif1=-1;
		*modif2=-1;
		*arite=2;
		fprintf(binaire, "00000110");
		return 1;
	}

	if(strcmp(temp, "MVI")==0)
	{
		*modif1=-1;
		*modif2=10;
		*arite=2;
		fprintf(binaire, "00000111");
		return 1;
	}

	if(strcmp(temp, "STORE")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001000");
		return 1;
	}

	if(strcmp(temp, "STX")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001001");
		return 1;
	}

	if(strcmp(temp, "STXR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001010");
		return 1;
	}

	if(strcmp(temp, "JUMP")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001011");
		return 1;
	}

	if(strcmp(temp, "JZ")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001100");
		return 1;
	}

	if(strcmp(temp, "JNZ")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001101");
		return 1;
	}

	if(strcmp(temp, "JP")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001110");
		return 1;
	}

	if(strcmp(temp, "JNP")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00001111");
		return 1;
	}
	
	if(strcmp(temp, "ADD")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010000");
		return 1;
	}

	if(strcmp(temp, "ADI")==0)
	{
		*modif1=10;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010001");
		return 1;
	}

	if(strcmp(temp, "ADR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010010");
		return 1;
	}

	if(strcmp(temp, "SUB")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010011");
		return 1;
	}

	if(strcmp(temp, "SUI")==0)
	{
		*modif1=10;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010100");
		return 1;
	}

	if(strcmp(temp, "SUR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010101");
		return 1;
	}

	if(strcmp(temp, "MUL")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010110");
		return 1;
	}

	if(strcmp(temp, "MUI")==0)
	{
		*modif1=10;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00010111");
		return 1;
	}

	if(strcmp(temp, "MUR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011000");
		return 1;
	}

	if(strcmp(temp, "DIV")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011001");
		return 1;
	}

	if(strcmp(temp, "DIVI")==0)
	{
		*modif1=10;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011010");
		return 1;
	}

	if(strcmp(temp, "DIVR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011011");
		return 1;
	}

	if(strcmp(temp, "INC")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00011100");
		return 1;
	}

	if(strcmp(temp, "DEC")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00011101");
		return 1;
	}

	if(strcmp(temp, "INCR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011110");
		return 1;
	}

	if(strcmp(temp, "DECR")==0)
	{
		*modif1=-1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00011111");
		return 1;
	}

	if(strcmp(temp, "CMP")==0)
	{
		*modif1=-1;
		*modif2=-1;
		*arite=2;
		fprintf(binaire, "00100000");
		return 1;
	}

	if(strcmp(temp, "CALL")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00100001");
		return 1;
	}

	if(strcmp(temp, "RETURN")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00100010");
		return 1;
	}

	if(strcmp(temp, "HALT")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00100011");
		return 1;
	}

	if(strcmp(temp, "PUSH")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00100100");
		return 1;
	}

	if(strcmp(temp, "POP")==0)
	{
		*modif1=0;
		*modif2=0;
		*arite=0;
		fprintf(binaire, "00100101");
		return 1;
	}

	if(strcmp(temp, "LDP")==0)
	{
		*modif1=4;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00100110");
		return 1;
	}

	if(strcmp(temp, "STP")==0)
	{
		*modif1=4;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00100111");
		return 1;
	}

	if(strcmp(temp, "STI")==0)
	{
		*modif1=1;
		*modif2=0;
		*arite=1;
		fprintf(binaire, "00101000");

		return 1;
	}
	return 0;
}

//-----------------------------------------------------------------------------------------------------------------------------

char *adr2bin(char *temp, char *bin)
{
	int n,i;
	n = (int)strtol(temp,(char **)NULL,16);
	for(i=7;i>=0;i--)
		bin[7-i] = ((n>>i)&1)+48;
	bin[8]='\0';
	return bin;
}

//-----------------------------------------------------------------------------------------------------------------------------

char *val2bin(char *temp, char *bin)
{
	int n,i;
	n = atoi(temp);
	if(n>127)
		n=256-n;
	for(i=7;i>=0;i--)
		bin[7-i] = ((n>>i)&1)+48;
	bin[8]='\0';
	return bin;
}


//-----------------------------------------------------------------------------------------------------------------------------

char *reg2bin(char *temp, char *bin)
{
	char t=temp[0];
	strcpy(bin, "");
	switch(t)
	{
		case 'A':
			if(temp[1]=='C') //si temp[1]=C => reg = ACC
				strcpy(bin, "00000100");
			else
				strcpy(bin, "00000001");
			break;
		case 'B':
			strcpy(bin, "00000010");
			break;
		case 'C':
			strcpy(bin, "00000011");
			break;
		default:
			strcpy(bin, "00000000");
			break;
	}
	return bin;
}

//-----------------------------------------------------------------------------------------------------------------------------

char *pph2bin(char *temp, char *bin)
{
	char t=temp[0];
	strcpy(bin, "");
	switch(t)
	{
		case 'C':
			strcpy(bin, "00000001");
			break;
		case 'E':
			strcpy(bin, "00000010");
			break;
		default:
			strcpy(bin, "00000011");
	}
	return bin;
}

//-----------------------------------------------------------------------------------------------------------------------------


