#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>


#define nopp 0
#define add 1
#define sub 2
#define mul 3
#define div 4
#define incra 5
#define incrb 6
#define decra 7
#define decrb 8
#define repa 9
#define repb 10


/*****************/

#define nb_seg 68
#define nb_boite 24

/*************/
/* REGISTRES */

#define regX 0
#define regA 1
#define regB 2
#define regC 3
#define regACC 4
/*************/

/*****************************/
/* pour faciliter l'ecriture */
#define ACC_ tab[0]
#define UAL_ tab[1]
#define X_ tab[2]
#define A_ tab[3]
#define B_ tab[4]
#define C_ tab[5]
#define RE_ tab[6]
#define RSP_ tab[7]
#define CLAVIER_ tab[8]
#define ECRAN_ tab[9]
#define PERIPH1_ tab[10]
#define PC_ tab[11]
#define RI_ tab[12]
#define SP_ tab[13]
#define RA_ tab[14]
#define RM_ tab[15]
#define RAM_ tab[16]
#define ldram_ tab[17]
#define cycle_ tab[18]
#define quit_ tab[19]
#define surbrille_ tab[20]
#define incdec_ tab[21]
#define RC_ tab[22]
#define decodeur_ tab[23]
/*****************************/

#define taille_RAM 128

GC      gc,gc1,gc2,gc3,gc4;
Display *display;
int     screen;
Window  win, root;
Cursor curs_fleche, curs_main;
Font police;
//int phase;
int rouge_1, rouge_2, rouge_3, bleu_1, bleu_2, bleu_3, vert_1, vert_2, jaune_1, jaune_2, bus_on, bus_off;

typedef struct
{
	Window win;
	int x,y;
	int largeur,hauteur;
	char type; // type de la boite T,U,R,N


	char *titre;
	int xt;
	int yt;
	int taille1;

	unsigned char eA; // entree A de UAL
	unsigned char eB; // entree B de l' UAL
	char op;// operation a faire  dansl'ual
	unsigned char res; // res = eA op eB

	unsigned char val;//boite contenant des entiers

	unsigned char *buffer; //juste pour la RAM
	unsigned char status;

	char *texte; // jsute pour les boites contenat du texte
	int taille2; // pour la taille du texte
}BOITE;

typedef struct
{
	char latence[15];
	char instruction[20];
	char saisie[35];
	char lat_periph[15];
}INFOS;



void creerBoite(BOITE *boite,int x, int y, int largueur, int hauteur, int borderwidth, int bordercolor, int background, char type, char *titre, int xt ,int yt, unsigned char valeur, char *texte);
void Dessiner(BOITE *boite);
void Dessiner_Tous(BOITE *tab);
void refresh(BOITE* tab);
void detruireBoite(BOITE *boite);
void resolution(int choix);
void ecrire_infos(INFOS *inf, int lequel);


