#include "util_mnemo.h"

#define nop_ 0
#define load_ 1
#define ldi_ 2
#define ldxr_ 3
#define ldx_ 4
#define li_ 5
#define move_ 6
#define mvi_ 7

#define store_ 8
#define stx_ 9
#define stxr_ 10

#define jump_ 11
#define jz_ 12
#define jnz_ 13
#define jp_ 14
#define jnp_ 15

#define add_ 16
#define adi_ 17
#define adr_ 18
#define sub_ 19
#define sui_ 20
#define sur_ 21

#define mul_ 22
#define mui_ 23
#define mur_ 24
#define div_ 25
#define divi_ 26
#define divr_ 27
#define inc_ 28
#define dec_ 29
#define incr_ 30
#define decr_ 31

#define cmp_ 32

#define call_ 33
#define return_ 34
#define halt_ 35
#define push_ 36
#define pop_ 37
#define ldp_ 38
#define stp_ 39
#define sti_ 40

int NOP(BOITE* tab,int** mat, INFOS *inf);
int LOAD(BOITE* tab,int** mat, INFOS *inf);

int LDI(BOITE* tab,int** mat, INFOS *inf);
int LDXR(BOITE* tab,int** mat, INFOS *inf);
int LDX(BOITE* tab,int** mat, INFOS *inf);
int LI(BOITE* tab,int** mat, INFOS *inf);

int MOVE(BOITE* tab,int** mat, INFOS *inf);
int MVI(BOITE* tab,int** mat, INFOS *inf);

int STORE(BOITE* tab,int** mat, INFOS *inf);
int STX(BOITE* tab,int** mat, INFOS *inf);
int STXR(BOITE* tab,int** mat, INFOS *inf);

int JUMP(BOITE* tab,int** mat, INFOS *inf);
int JZ(BOITE* tab,int** mat, INFOS *inf);
int JNZ(BOITE* tab,int** mat, INFOS *inf);
int JP(BOITE* tab,int** mat, INFOS *inf);
int JNP(BOITE* tab,int** mat, INFOS *inf);

int ADD(BOITE* tab,int** mat, INFOS *inf);
int ADI(BOITE* tab,int** mat, INFOS *inf);
int ADR(BOITE* tab,int** mat, INFOS *inf);
int SUB(BOITE* tab,int** mat, INFOS *inf);
int SUI(BOITE* tab,int** mat, INFOS *inf);
int SUR(BOITE* tab,int** mat, INFOS *inf);
int MUL(BOITE* tab,int** mat, INFOS *inf);
int MUI(BOITE* tab,int** mat, INFOS *inf);
int MUR(BOITE* tab,int** mat, INFOS *inf);
int DIV(BOITE* tab,int** mat, INFOS *inf);
int DIVI(BOITE* tab,int** mat, INFOS *inf);
int DIVR(BOITE* tab,int** mat, INFOS *inf);

int INC(BOITE* tab,int** mat, INFOS *inf);
int DEC(BOITE* tab,int** mat, INFOS *inf);
int INCR(BOITE* tab,int** mat, INFOS *inf);
int DECR(BOITE* tab,int** mat, INFOS *inf);

int CMP(BOITE* tab,int** mat, INFOS *inf);

int CALL(BOITE* tab,int** mat, INFOS *inf);
int RETURN(BOITE* tab,int** mat, INFOS *inf);

int PUSH(BOITE* tab,int** mat, INFOS *inf);
int POP(BOITE* tab,int** mat, INFOS *inf);

int LDP(BOITE* tab,int** mat, INFOS *inf);
int STP(BOITE* tab,int** mat, INFOS *inf);

int STI(BOITE* tab,int** mat, INFOS *inf);

int decoder(BOITE* tab,int** mat, INFOS *inf, char *verif_halt);
